 /*
  * CGI script to send mail without calling a shell
  * by Arjan de Vet (devet@iaehv.nl)
  * modified by Reinier Post (reinpost@win.tue.nl)
  * portions of code taken from Wietse Venema (wswietse@win.tue.nl)
  */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include "proto.h"
#include "util.h"

#ifndef MY_EMAIL
#define MY_EMAIL "webmaster@forgot.to.configure.form.properly"
#endif

#ifndef WARN_GIF_PATH
#define WARN_GIF_PATH "/icons/warn.gif"
#endif

#ifndef SMTP_BINARY
#define SMTP_BINARY "/bin/smtp"
#endif

typedef struct {
    char *name;
    char *val;
} entry;

static inline char *my_getenv(char *name)
{
  char *value = getenv(name);
  return(value ? value : "");
}

int
main(int argc, char *argv[]) {
    entry entries[20];
    register int x,m=0;
    int cl;

    int pid, pfd[2];
    FILE *smtp;
    
    char *name = "", *email = "", *message = "";
    char *emailname = "";

    printf("Content-type: text/html\n\n");

    if(strcmp(my_getenv("REQUEST_METHOD"),"POST")) {
        printf("This script should be referenced with a METHOD of POST.\n");
        printf("If you don't understand this, see this ");
        printf("<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c",10);
        exit(1);
    }
    if(strcmp(my_getenv("CONTENT_TYPE"),"application/x-www-form-urlencoded")) {
        printf("This script can only be used to decode form results. \n");
        exit(1);
    }
    cl = atoi(my_getenv("CONTENT_LENGTH"));

    for(x=0;cl && (!feof(stdin));x++) {
        m=x;
        entries[x].val = fmakeword(stdin,'&',&cl);
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        entries[x].name = makeword(entries[x].val,'=');
    }

    for (x = 0; x <= m; x++) {
        if (strcmp(entries[x].name,"name") == 0)
	    name = entries[x].val;
        if (strcmp(entries[x].name,"email") == 0)
	    email = entries[x].val;
        if (strcmp(entries[x].name,"message") == 0)
	    message = entries[x].val;
    }

    if ((strcmp(email,"") == 0 && strcmp(name,"") == 0)
	|| strcmp(message,"") == 0) {
	printf("<TITLE> Feedback Form Error </TITLE>\n\n");
	printf("<H2> <IMG SRC=\"WARN_GIF_PATH\" ALT=WARNING></H2>\n\n");
	printf("Your form is incomplete. I need at least a name or email ");
	printf("address and a non-empty message\n");
	return(1);
    }
    
    emailname = (char *) malloc(strlen(email)+strlen(name)+4);
    sprintf(emailname,"%s (%s)",email,name);
			       
    if (pipe(pfd) < 0)
	exit (1);
    if ((pid = fork()) < 0)
	exit (1);
    else if (pid > 0)	    /* parent */
	close(pfd[0]);	    /* close read pipe */
    else {		    /* child */
	close(pfd[1]);	    /* close write pipe */
	if (pfd[0] != STDIN_FILENO) {
	    if (dup2(pfd[0],STDIN_FILENO) != STDIN_FILENO)
		exit (1);
	    close(pfd[0]);
	}
	execl(SMTP_BINARY,"smtp","-f",emailname,"-r",emailname,
		"-s","WWW feedback",
	    MY_EMAIL,(char *) 0);
    }
    smtp = fdopen(pfd[1],"w");

    fprintf(smtp,"Remote host: %s\n", my_getenv("REMOTE_HOST"));
    fprintf(smtp,"Remote addr: %s\n", my_getenv("REMOTE_ADDR"));
    fprintf(smtp,"Apparent script location: http://%s:%s%s\n\n",
	my_getenv("SERVER_NAME"), my_getenv("SERVER_PORT"),
	my_getenv("SCRIPT_NAME"));
    fprintf(smtp,"%s\n",message);
    fclose(smtp);
    
    printf("<TITLE> Feedback Form </TITLE>\n\n");

    if (pid == waitpid(pid,NULL,0)) {
	printf("<H2> Feedback form OK </H2>\n\n");
	printf("Your feedback form has been mailed succesfully to %s\n",
	       MY_EMAIL);
    } else {
	printf("<H2> Problems! </H2>\n\n");
	printf("PROBLEMS mailing your feedback form to %s;\n", MY_EMAIL);
	printf("the special-purpose mail program, '%s', could not be started\n",
	  SMTP_BINARY);
    }

    return (0);
}
