/*
 * originally from Jim Brown, comes with NCSA httpd and derivatives
 * hack to avoid popen() and other changes by Arjan de Vet (devet@iaehv.nl)
 * his version 1.6 was used
 * synch with CGI version by Reinier Post (reinpost@win.tue.nl)
 */

#include <stdio.h>
#ifndef NO_STDLIB_H
#include <stdlib.h>
#else
char *getenv();
#endif

#include <string.h>
#include <unistd.h>

#include "util.h"

#define LF      10

/* my own relative URL pathname - SET THIS while compiling - see Makefile */
/* email address for responses, used in form */
#ifndef MY_EMAIL
#define MY_EMAIL "shouldbe@phonebook.maintainers.email.address"
#endif

/* where is the ph binary to do the actual search? */
#ifndef PH_BINARY
#define PH_BINARY "/usr/local/bin/ph"
#endif

#define HTML_BREAK      printf("<P>%c", LF);
typedef struct {
    char name[128];
    char val[128];
} entry;

typedef struct {
    char qfield[256];
    int  qlen;
    char qname[256];
} fields;

void send_doc(int which);

/* configure these: */

static fields idxfields[] =
{
  {"Qname", 256, "Name"},
  {"Qemail", 128, "E-mail Address"},
  {"Qoffice_phone", 60, "Office Phone Number"},
  {NULL, 0, NULL}
};

static fields othersearchfields[] =
{
  {"Qdepartment", 64, "Department"},
  (NULL, 0, NULL)
};

void send_doc(int which) {
    int x;

    printf("<HTML><HEAD>%c", LF);
    printf("<TITLE>Form for CSO PH query</TITLE>%c", LF);
    printf("</HEAD><BODY>%c", LF);
    printf("<H1>Form for CSO PH query</H1>%c", LF);
    printf("This form will send a PH query to the specified ph server.%c", LF);
    HTML_BREAK
    printf("<HR>%c", LF);

    printf("<FORM ACTION=\"http://%s:%s%s\">%c", getenv("SERVER_NAME"),
           getenv("SERVER_PORT"), getenv("SCRIPT_NAME"), LF);

    printf("PH Server:<INPUT TYPE=\"text\" NAME=\"Jserver\" VALUE=\"cso.tue.nl\" MAXLENGTH=\"256\">%c", LF);
    HTML_BREAK

    printf("<H3>At least one of these fields must be specified:</H3><UL>%c",LF)
;
    for(x=0; idxfields[x].qlen != 0; x++)
        printf("<LI><INPUT TYPE=\"text\" NAME=\"%s\" MAXLENGTH=\"%d\">%s%c"
               ,idxfields[x].qfield, idxfields[x].qlen, idxfields[x].qname,LF);

    printf("</UL>%c", LF);

    if (!(which&0x10)) {
        printf("<A HREF=\"%s?Jform=%d\"><H3>Show additional fields to narrow query</H3></A>%c", getenv("SCRIPT_NAME"), (which | 0x10), LF);
        }
    else {
        printf("<H3>Additional fields to narrow query:</H3><UL>%c",LF);

        for(x=0; othersearchfields[x].qlen != 0; x++)
            printf("<LI><INPUT TYPE=\"text\" NAME=\"%s\" MAXLENGTH=\"%d\">%s%c"
                   ,othersearchfields[x].qfield, othersearchfields[x].qlen,
                   othersearchfields[x].qname,LF);

        printf("</UL>%c", LF);

        printf("<A HREF=\"%s?Jform=%d\">Show fewer query fields</A>%c", getenv(
"SCRIPT_NAME"), (which & 0x01), LF);
        }

    HTML_BREAK

    if (!(which & 0x01)) {
        printf("<A HREF=\"%s?Jform=%d\"><H3>Return more than default fields</H3></A>%c", getenv("SCRIPT_NAME"), (which | 0x01), LF);
        }
    else {
        printf("<H3>Fields to return:</H3><UL>%c", LF);

        for(x=0; idxfields[x].qlen != 0; x++)
            printf("<LI><INPUT TYPE=\"checkbox\" NAME=\"return\" VALUE=\"%s\">%s%c", &(idxfields[x].qfield[1]), idxfields[x].qname, LF);

        for(x=0; othersearchfields[x].qlen != 0; x++)
            printf("<LI><INPUT TYPE=\"checkbox\" NAME=\"return\" VALUE=\"%s\">%s%c", &(othersearchfields[x].qfield[1]), othersearchfields[x].qname, LF);

        printf("</UL>%c", LF);

        printf("<A HREF=\"%s?Jform=%d\">Return default fields</A>%c", getenv("SCRIPT_NAME"), (which & 0x10), LF);
        }

    HTML_BREAK
    printf("<INPUT TYPE=\"submit\">%c", LF);
    printf("</FORM>%c", LF);

    printf("<HR>%c<ADDRESS>", LF);
    printf("Questions, comments to: <a href=\"mailto:%s\">%s</a>%c",
      MY_EMAIL, MY_EMAIL, LF);
    printf("</ADDRESS>%c", LF);
    printf("</BODY></HTML>%c", LF);
}

/*
 * The following is a VERY UGLY hack to avoid /bin/sh in popen(3)
 */

static int pid;

FILE *
mypopen(char *command, char *type) {
    int pfd[2];
    int i;
    char *p,*q;
    char *vector[256];

    i = 0;
    q = command;
    while ((q != NULL) && ((p = strchr(q,32)) != NULL)) {
	vector[i] = q;
	*p = (char) 0;
	q = p + 1;
	/* skip multiple spaces */
	while (*q == ' ') q++;
	i++;
    }
    if (q != NULL) {
	vector[i] = q;
	i++;
    }
    vector[i] = NULL;
    
    if (pipe(pfd) < 0)
	exit(1);

    if ((pid = fork()) < 0)
	exit(1);
    else if (pid > 0)	    /* parent */
	close(pfd[1]);	    /* close write pipe */
    else {		    /* child */
	close(pfd[0]);	    /* close read pipe */
	if (pfd[1] != STDOUT_FILENO) {
	    if (dup2(pfd[1],STDOUT_FILENO) != STDOUT_FILENO)
		exit(1);
	    close(pfd[1]);
	}
	execv(vector[0], vector);
    }
    return(fdopen(pfd[0],"r"));
}

int mypclose(FILE *fd) {
    waitpid(pid,NULL,0);
    return(0);
}

/* end of very ugly hack.  code by Arjan de Vet (devet@iaehv.nl) */

main(int argc, char *argv[]) {
    entry entries[64];
    register int x,m=0;
    char *cl;
    char returnstr[1024], typestr[4098], commandstr[8192], serverstr[256];
    int atleastonereturn = 0, atleastonequery = 0, which = 0;
    FILE *phfp;

    printf("Content-type: text/html%c%c",LF,LF);

    strcpy(returnstr, "return ");
    strcpy(typestr, " ");

    cl = getenv("QUERY_STRING");

    if((!cl) || (!cl[0])) {
        send_doc(0);
        exit(1);
    }

    for(x=0;cl[0] != '\0';x++) {
        m=x;
        getword(entries[x].val,cl,'&');
        plustospace(entries[x].val);
        unescape_url(entries[x].val);
        getword(entries[x].name,entries[x].val,'=');
    }

    for(x=0; x <= m; x++) {
/*      printf("%s = %s %c", entries[x].name, entries[x].val, LF); */

        if (!strcmp(entries[x].name, "return")) {
            strcat(returnstr, entries[x].val);
            strcat(returnstr, " ");
            atleastonereturn = 1;
            }
        else if ((entries[x].name[0] == 'Q') && strlen(entries[x].val)) {
            strcat(typestr, &(entries[x].name[1]));
            strcat(typestr, "=");
            strcat(typestr, entries[x].val);
            strcat(typestr, " ");
            atleastonequery = 1;
            }
        else if (!strcmp(entries[x].name, "Jserver"))
            strcpy(serverstr, entries[x].val);
        else if (!strcmp(entries[x].name, "Jform"))
            if (sscanf(entries[x].val, "%d", &which)) {
                send_doc(which);
                exit(1);
                }
            else exit(1);
        }

    printf("<H1>Query Results</H1>%c", LF);
    HTML_BREAK

    if (!atleastonequery) printf("<B>You did not enter a query!</B>%c",LF);
    else {
        sprintf(commandstr, "%s -m ", PH_BINARY);
        if (strlen(serverstr)) {
           strcat(commandstr, " -s ");
           /* escape_shell_cmd(serverstr); */
	   /* put this IN if you're calling a shell */
	   /* comment it out otherwise, or ph's wildcards won't work */
           strcat(commandstr, serverstr);
           strcat(commandstr, " ");
           }
        /* escape_shell_cmd(typestr); */  /* see 5 lines up */
        strcat(commandstr, typestr);
        if (atleastonereturn) {
           /* escape_shell_cmd(returnstr); */  /* see 5 lines up */
           strcat(commandstr, returnstr);
        }

        printf("%s%c", commandstr, LF);
        printf("<PRE>%c", LF);

        phfp = mypopen(commandstr,"r");
	send_fd(phfp, stdout);

        printf("</PRE>%c", LF);
	mypclose(phfp);
        }
    return(0);
}
