/*
 * $Id: proto.h,v 1.2 1993/10/19 11:41:37 devet Exp $
 *
 * Additional prototypes for SUNOS 4.1.1
 *
 * $Log: proto.h,v $
 * Revision 1.2  1993/10/19  11:41:37  devet
 * Added prototypes for read(2), write(2) and close(2).
 *
 * Revision 1.1  1993/10/01  12:11:40  devet
 * Initial revision
 *
 */

#ifndef __sys_unistd_h
#ifndef _UNISTD_H
/* if GCC doesn't do it already */

#include <stdio.h>	/* for FILE */
#include <sys/types.h>
#include <sys/socket.h>

/* prototypes for some common functions */

extern int fclose (FILE *);
extern int fflush (FILE *);
extern int fgetc (FILE *);
extern int fgetpos (FILE *, long *);
extern int fprintf (FILE *, const char *, ...);
extern int fputc (int, FILE *);
extern int fputs (const char *, FILE *);
extern int fscanf (FILE *, const char *, ...);
extern int pclose (FILE *);
extern void perror (const char *);
extern int printf (const char *, ...);
extern int puts (const char *);
extern int remove (const char *);
extern int rename (const char *, const char *);
extern void rewind (FILE *);
extern int scanf (const char *, ...);
extern void setbuf (FILE *, char *);
extern int setvbuf (FILE *, char *, int, __SIZE_TYPE__ );
extern int sscanf (const char *, const char *, ...);

/* prototypes for syscalls */

int connect (int, struct sockaddr *, int);
int socket (int, int, int);

extern int read (int, char *, int);
extern int write (int, char *, int);
extern int close (int);

extern int atoi (const char *);

extern void bzero (void *, int);
extern void bcopy (const void *, void *, int);

extern time_t time(time_t *);

extern int getpeername(int, struct sockaddr *, int *);

#endif /* _UNISTD_H */
#endif /* __sys_unistd_h */
